diff --git a/bin/varnishd/cache/cache_ws.c b/bin/varnishd/cache/cache_ws.c
index 7b8df6d23e..e98e2cc69d 100644
--- a/bin/varnishd/cache/cache_ws.c
+++ b/bin/varnishd/cache/cache_ws.c
@@ -262,7 +262,7 @@ WS_ReserveSize(struct ws *ws, unsigned bytes)
 	if (bytes < b2)
 		b2 = PRNDUP(bytes);
 
-	if (ws->f + b2 > ws->e) {
+	if (ws->f + b2 >= ws->e) {
 		WS_MarkOverflow(ws);
 		return (0);
 	}
diff --git a/bin/varnishtest/tests/r03131.vtc b/bin/varnishtest/tests/r03131.vtc
new file mode 100644
index 0000000000..2722b748aa
--- /dev/null
+++ b/bin/varnishtest/tests/r03131.vtc
@@ -0,0 +1,24 @@
+varnishtest "Test workspace functions in vmod_vtc"
+
+varnish v1 -vcl {
+	import vtc;
+	import std;
+
+	backend dummy {.host = "${bad_backend}"; }
+
+	sub vcl_recv {
+		return (synth(200));
+	}
+
+	sub vcl_synth {
+		set resp.http.res1 = vtc.workspace_reserve(client, 1024 * 1024);
+		vtc.workspace_alloc(client, -1);
+		set resp.http.res2 = vtc.workspace_reserve(client, 8);
+		set resp.http.res3 = vtc.workspace_reserve(client, 8);
+	}
+} -start
+
+client c1 {
+	txreq
+	rxresp
+} -run
